import time, threading, math, random, string, urllib2
from httplib import HTTPConnection
from urllib import urlencode

class speedTest:

       def __init__(self):
              self.base = 'sp1.ais.co.th'  # AIS speed test server.
              self.ul_files = [132884, 493638]
              self.table = []

       def getData(self,size):  # Data random genrator
              return ''.join(random.choice(string.ascii_uppercase + string.digits) for _ in range(size))

       def getConnection(self,url):
              connection = HTTPConnection(url)
              connection.connect()
              return connection

       def post(self,con, data):
              url = "/speedtest/upload.php?x="
              con.request('POST', url, data,
                          {'Connection': 'Keep-Alive', 'Content-Type': 'application/x-www-form-urlencoded'})
              response = con.getresponse()
              reply = response.read().decode('utf-8')
              self.table.append(int(reply.split('=')[1]))

       def ul(self):
              num_run = 2
              connections = [self.getConnection(self.base) for i in range(num_run)]
              data = [urlencode({'content0': self.getData(s)}) for s in self.ul_files]
              start = time.time()
              for d in data:
                     threads = []
                     for r in range(num_run):
                            thread = threading.Thread(target=self.post, args=(connections[r], d))
                            thread.start()
                            threads.append(thread)
                     for t in threads: t.join()
              total = (time.time() - start) * 1000
              return (sum(self.table) * 8000) / total

       def ping(self):
              con = self.getConnection(self.base)
              t = []
              w = 0
              for i in range(5):
                     start = time.time()
                     con.request('GET', '/speedtest/latency.txt', None, {'Connection': 'Keep-Alive'})
                     con.getresponse().read()
                     end = time.time() - start
                     t.append(end)
                     if end > w:
                            w = end
              t.remove(w)
              return sum(t) * 250

       def dl(self):
              url = "http://" + self.base + "/speedtest/random1500x1500.jpg"  # 4.3MB file from TOT.
              f = urllib2.urlopen(url)
              size = int(f.headers.items()[0][1])
              chunk = 1024 * 16  # randomly selected a chunk size in bytes
              table = []
              c = f.read(chunk)
              # can run the test for 15secs or download the complet file.
              # s = time.time()
              # while (time.time()-s) < 15:
              while len(c) < size:
                     # print len(c)
                     start = time.time()
                     c += f.read(chunk)
                     end = time.time()
                     off = end - start
                     print off*8
                     # table.append((chunk) / float((end- start)))
                     if off != 0:
                            table.append((chunk) / off)
                     if not c: break
              table.sort()
              # remove the Fastest 30% and slowest 10%. REF: https://support.ookla.com/hc/en-us/articles/234577428
              index1 = int(len(table) / 100) * 70
              index = int(len(table) / 100) * 10
              return ((sum(table[index:index1]) / len(table[index:index1]))) * 8