import math
import threading
import Queue
from Tkinter import *
import ttk as tk

from SpeedTest import speedTest

size = 2

class uiSpeed:

       def __init__(self,root):
              self.root = root
              self.testFrame = Frame(root, width=600, height=300,bg='#000000')
              self.testFrame.pack(side=TOP)

              resultFrame = LabelFrame(root,text='Result',width=300,height=250,font=("Courier New", size*20),bg='#000000',fg='#C0C0C0')
              resultFrame.pack(side=TOP)

              self.pingResult = Label(resultFrame,text='Ping     :',font=("Courier New", size*10),bg='#000000',fg='#C0C0C0')
              self.pingResult.pack(anchor=W)
              self.downmResult = Label(resultFrame,text='Download :',font=("Courier New", size*10),bg='#000000',fg='#C0C0C0')
              self.downmResult.pack(anchor=W)
              self.downkResult = Label(resultFrame, text='Download :',font=("Courier New", size*10),bg='#000000',fg='#C0C0C0')
              self.downkResult.pack(anchor=W)
              self.upmResult = Label(resultFrame, text='Upload   :',font=("Courier New", size*10),bg='#000000',fg='#C0C0C0')
              self.upmResult.pack(anchor=W)
              self.upkResult = Label(resultFrame, text='Upload   :',font=("Courier New", size*10),bg='#000000',fg='#C0C0C0')
              self.upkResult.pack(anchor=W)

              s = tk.Style()
              s.theme_use('clam')
              s.configure("red.Horizontal.TProgressbar", troughcolor='black', background='blue')
              self.statusBar = tk.Progressbar(self.root,orient='horizontal',length=200,mode='indeterminate',style="red.Horizontal.TProgressbar")
              self.statusBar.pack(side=BOTTOM,fill=X)
              Label(self.testFrame, text='SpeedTest',font=("Centaur", size*50),fg='#C0C0C0',bg='#000000').grid(row=0,column=0,pady=10)
              self.startSpeedButton = Button(self.testFrame, text='BEGIN TEST', command=self.run_click,font=("Courier New", size*12),bg='#000080',fg='#FFFFFF')
              self.startSpeedButton.grid(row=1,column=0,pady=50)

       def run_click(self):
              self.statusBar.start()
              self.startSpeedButton.config(state='disabled')
              self.q = Queue.Queue()
              ThreadedTask(self.q).start()
              self.root.after(100, self.process_queue)
       def process_queue(self):
              try:
                     result = self.q.get(0)
                     self.pingResult.config(text='Ping     : %r MS' % round(result[0], 2))
                     self.downmResult.config(text='Download : %r Mbps' % round(result[1] / math.pow(2, 20), 2))
                     self.downkResult.config(text='Download : %r Kbps' % round(result[1] / math.pow(2, 10), 2))
                     self.upmResult.config(text='Upload   : %r Mbps' % round(result[2] / math.pow(2, 20), 2))
                     self.upkResult.config(text='Upload   : %r Kbps' % round(result[2] / math.pow(2, 10), 2))
                     self.statusBar.stop()
                     self.startSpeedButton.config(state='normal')
              except Queue.Empty:
                     self.root.after(100, self.process_queue)

class ThreadedTask(threading.Thread):
       def __init__(self, q):
              threading.Thread.daemon = True
              threading.Thread.__init__(self)
              self.q = q

       def run(self):
              s = speedTest()
              p = s.ping()
              d = s.dl()
              u = s.ul()
              result = [p,d,u]
              self.q.put(result)


root = Tk()
root.title('SpeedTest')
root.resizable(width=False, height=False)
root.geometry('%dx%d' % (size*400, 700))
root.config(background='#000000')
ui = uiSpeed(root)
root.mainloop()
